#!/bin/awk -f


BEGIN {
  IGNORECASE=0;
  oldletter = "";
  opened = 0;
  in_block = 0;
  
  working = 0;
}

/^[ \t]/ {
  if(in_block) {
    print SPACE"  break;";
    print SPACE"  }";
  }
  in_block = 0;
  print $0;
}

/^[a-z0-9]/ {
  letter = substr($0,1,1);
  rest = substr($0,2);
  if (!in_block) {
    # entering new block
    print SPACE"  switch (*name++) {";
    print SPACE"  case '" letter "':";
  }
  else {
    # next letter
    if (letter!=oldletter) {
      print SPACE"  break;";
      print SPACE"  case '" letter "':";
    }
  }

  in_block = 1;
  print rest;
  oldletter = letter;
  working = 1;
}

/^@@/ {
  tag = substr($1,3);
  start = $2;
  end = $3;
  data = $4;
  printf SPACE"    handlers->starthandler = ";
  if (!start) print "NULL;"; else print tag "_start_handler;";
  printf SPACE"    handlers->endhandler = ";
  if (!end) print "NULL;"; else print tag "_end_handler;";
  printf SPACE"    handlers->datahandler = ";
  if (!data) print "NULL;"; else print tag "_data_handler;";

  printf SPACE"  use_default_handler = 0;";

  working = 1;
}


END {
  exit(!working);
}
